macroScript ToggleManipulators category:"Manipulators"


(





----------------------------------------------------------------------------------------


--   Script:		MAGMApulators:Toggle Manipulators 


--	 Version:		v0.4


--	 Started:       11/01/00


--	 Last Modified: 01/29/01


--   Description:	Supplements the MAGMApulators package with


--				 	the option to enable/disable any of the provided manipulators.


--	 Documentation: Visit http://www.gfxcentral.com/bobo/mxs4


--	 Code by:		Borislav Petrov [Boboland]		bobo@email.archlab.tuwien.ac.at


----------------------------------------------------------------------------------------





persistent global geometry_manipulators_enabled 


persistent global modifier_manipulators_enabled 


persistent global lights_manipulators_enabled 






global togglemanip_floater





rollout geommanip_roll "Geometry" rolledup:true


(


checkbutton toggle_height "Height/Size" checked:true width:70 align:#left across:2 highlightcolor:(color 200 255 200)


checkbutton toggle_width "Width" checked:true width:70 align:#right highlightcolor:(color 200 255 200)


checkbutton toggle_length "Length" checked:true width:70 align:#left across:2 highlightcolor:(color 200 255 200)


checkbutton toggle_radius "Radius" checked:true width:70 align:#right highlightcolor:(color 200 255 200)


checkbutton toggle_segs "Segments" checked:true width:70 align:#left across:2 highlightcolor:(color 200 255 200)


checkbutton toggle_heightsegs "Height Segs" checked:true width:70 align:#right highlightcolor:(color 200 255 200)


checkbutton toggle_widthsegs "Width Segs" checked:true width:70 align:#left across:2 highlightcolor:(color 200 255 200)


checkbutton toggle_lengthsegs "Length Segs" checked:true width:70 align:#right highlightcolor:(color 200 255 200)


checkbutton toggle_capheight "Cap Height" checked:true width:70 align:#left across:2 highlightcolor:(color 200 255 200)


checkbutton toggle_turns "Turns/Points" checked:true width:70 align:#right  highlightcolor:(color 200 255 200)





button all_on "All On" across:3 align:#left width:48 height:18


button all_off "All Off"  align:#center width:48 height:18


button all_invert "Invert" align:#right width:48 height:18





fn set_geommanip_toggles =


(


persistent global geometry_manipulators_enabled = #()


for i = 1 to 20 do geometry_manipulators_enabled[i] = true


geometry_manipulators_enabled[1]= toggle_height.state 


geometry_manipulators_enabled[2]= toggle_width.state 


geometry_manipulators_enabled[3]= toggle_length.state 


geometry_manipulators_enabled[4]= toggle_radius.state 


geometry_manipulators_enabled[5]= toggle_segs.state 


geometry_manipulators_enabled[6]= toggle_heightsegs.state 


geometry_manipulators_enabled[7]= toggle_widthsegs.state 


geometry_manipulators_enabled[8]= toggle_lengthsegs.state 


geometry_manipulators_enabled[9]= toggle_capheight.state

geometry_manipulators_enabled[10]= toggle_turns.state






sel = selection as array


select sel


)





fn update_geommanip_switches =


(


geommanip_roll.toggle_height.state = geometry_manipulators_enabled[1]


geommanip_roll.toggle_width.state = geometry_manipulators_enabled[2]


geommanip_roll.toggle_length.state = geometry_manipulators_enabled[3]


geommanip_roll.toggle_radius.state = geometry_manipulators_enabled[4]


geommanip_roll.toggle_segs.state = geometry_manipulators_enabled[5]


geommanip_roll.toggle_heightsegs.state = geometry_manipulators_enabled[6]


geommanip_roll.toggle_widthsegs.state = geometry_manipulators_enabled[7]


geommanip_roll.toggle_lengthsegs.state = geometry_manipulators_enabled[8]


geommanip_roll.toggle_capheight.state = geometry_manipulators_enabled[9]

geommanip_roll.toggle_turns.state = geometry_manipulators_enabled[10]

sel = selection as array


select sel


)





on all_on pressed do 


(


for i = 1 to 20 do geometry_manipulators_enabled[i] = true


update_geommanip_switches()


)





on all_off pressed do 


(


for i = 1 to 20 do geometry_manipulators_enabled[i] = false


update_geommanip_switches()


)





on all_invert pressed do 


(


for i = 1 to 20 do try(geometry_manipulators_enabled[i] = not geometry_manipulators_enabled[i])catch()


update_geommanip_switches()


)











on toggle_height changed state do set_geommanip_toggles()


on toggle_width changed state do set_geommanip_toggles()


on toggle_length changed state do set_geommanip_toggles()


on toggle_radius changed state do set_geommanip_toggles()


on toggle_segs changed state do set_geommanip_toggles()


on toggle_heightsegs changed state do set_geommanip_toggles()


on toggle_widthsegs changed state do set_geommanip_toggles()


on toggle_lengthsegs changed state do set_geommanip_toggles()


on toggle_capheight changed state do set_geommanip_toggles()

on toggle_turns changed state do set_geommanip_toggles()

)





rollout modmanip_roll "Modifiers" rolledup:true


(


checkbutton toggle_angle "Angle" checked:true width:70 align:#left across:2 highlightcolor:(color 200 255 200)


checkbutton toggle_direction "Direction" checked:true width:70 align:#right highlightcolor:(color 200 255 200)


checkbutton toggle_amount "Amount" checked:true width:70 align:#left across:2 highlightcolor:(color 200 255 200)


checkbutton toggle_void "" checked:false width:70 align:#right  highlightcolor:(color 200 255 200) enabled:false





button all_on "All On" across:3 align:#left width:48 height:18


button all_off "All Off"  align:#center width:48 height:18


button all_invert "Invert" align:#right width:48 height:18





fn set_modmanip_toggles =


(


modifier_manipulators_enabled = #()


for i = 1 to 20 do modifier_manipulators_enabled[i] = true


modifier_manipulators_enabled[1]= toggle_angle.state 


modifier_manipulators_enabled[2]= toggle_direction.state 


modifier_manipulators_enabled[3]= toggle_amount.state 


sel = selection as array


select sel


)





fn update_modmanip_switches =


(


toggle_angle.state = modifier_manipulators_enabled[1]


toggle_direction.state = modifier_manipulators_enabled[2]


toggle_amount.state = modifier_manipulators_enabled[3]


sel = selection as array


select sel


)





on all_on pressed do 


(


for i = 1 to 20 do modifier_manipulators_enabled[i] = true


update_modmanip_switches()


)





on all_off pressed do 


(


for i = 1 to 20 do modifier_manipulators_enabled[i] = false


update_modmanip_switches()


)





on all_invert pressed do 


(


for i = 1 to 20 do try(modifier_manipulators_enabled[i] = not modifier_manipulators_enabled[i])catch()


update_modmanip_switches()


)











on toggle_angle changed state do set_modmanip_toggles()


on toggle_direction changed state do set_modmanip_toggles()


on toggle_amount changed state do set_modmanip_toggles()


)






rollout lightsmanip_roll "Lights" rolledup:true

(



checkbutton toggle_nearstart "NearStart" checked:true width:70 align:#left across:2 highlightcolor:(color 200 255 200)

checkbutton toggle_nearend "NearEnd" checked:true width:70 align:#right highlightcolor:(color 200 255 200)



checkbutton toggle_farstart "FarStart" checked:true width:70 align:#left across:2 highlightcolor:(color 200 255 200)

checkbutton toggle_farend "FarEnd" checked:true width:70 align:#right highlightcolor:(color 200 255 200)



checkbutton toggle_decay "Decay" checked:true width:70 align:#left across:2 highlightcolor:(color 200 255 200)

checkbutton toggle_falloff "Falloff" checked:true width:70 align:#right  highlightcolor:(color 200 255 200) 





button all_on "All On" across:3 align:#left width:48 height:18

button all_off "All Off"  align:#center width:48 height:18

button all_invert "Invert" align:#right width:48 height:18



fn set_lightsmanip_toggles =

(

lights_manipulators_enabled = #()

for i = 1 to 20 do lights_manipulators_enabled[i] = true

lights_manipulators_enabled[1]= toggle_decay.state 

lights_manipulators_enabled[2]= toggle_nearstart.state 

lights_manipulators_enabled[3]= toggle_nearend.state 

lights_manipulators_enabled[4]= toggle_farstart.state 

lights_manipulators_enabled[5]= toggle_farend.state 

lights_manipulators_enabled[6]= toggle_falloff.state 

sel = selection as array

select sel

)





fn update_lightsmanip_switches =

(

toggle_decay.state = lights_manipulators_enabled[1]

toggle_nearstart.state = lights_manipulators_enabled[2]

toggle_nearend.state = lights_manipulators_enabled[3]

toggle_farstart.state = lights_manipulators_enabled[4]

toggle_farend.state = lights_manipulators_enabled[5]

toggle_falloff.state = lights_manipulators_enabled[6]

sel = selection as array

select sel

)





on all_on pressed do 

(

for i = 1 to 20 do lights_manipulators_enabled[i] = true

update_lightsmanip_switches()

)



on all_off pressed do 

(

for i = 1 to 20 do lights_manipulators_enabled[i] = false

update_lightsmanip_switches()

)



on all_invert pressed do 

(

for i = 1 to 20 do try(lights_manipulators_enabled[i] = not lights_manipulators_enabled[i])catch()

update_lightsmanip_switches()

)



on toggle_decay changed state do set_lightsmanip_toggles()

on toggle_nearstart changed state do set_lightsmanip_toggles()

on toggle_nearend changed state do set_lightsmanip_toggles()

on toggle_farstart changed state do set_lightsmanip_toggles()

on toggle_farend changed state do set_lightsmanip_toggles()

on toggle_falloff changed state do set_lightsmanip_toggles()

)






try(closerolloutfloater togglemanip_floater)catch()


togglemanip_floater = newrolloutfloater "Toggle Manip." 200 220 100 200


addrollout geommanip_roll togglemanip_floater


addrollout modmanip_roll togglemanip_floater 


addrollout lightsmanip_roll togglemanip_floater 






if geometry_manipulators_enabled == undefined then 


	geommanip_roll.set_geommanip_toggles()


else


	geommanip_roll.update_geommanip_switches()





if modifier_manipulators_enabled == undefined then 


	modmanip_roll.set_modmanip_toggles()


else


	modmanip_roll.update_modmanip_switches()




if lights_manipulators_enabled == undefined then 

	lightsmanip_roll.set_lightsmanip_toggles()

else

	lightsmanip_roll.update_lightsmanip_switches()






)--end script
